// Reprsentiert ein Chromosom 
// Chromosomseintrgen (Gene) sind hier Bitstrings

package ga;

import java.util.BitSet;


/**
 ** Diese Klasse reprsentiert ein einzelnens Chromosom, welches durch
 ** einen BitString dargestellt wird
 **
 ** 
 */
public class Chromosom_bit
{
   BitSet chrom;                 // Genotype - bit string
   int laenge;
      
  
  /**
   ** Dieser Konstruktor erzeugt ein neues Chromosom.
   **
   */
  
   public Chromosom_bit(BitSet chrom, int laenge)
   {
      // erzeugen eines neuen Chromosoms durch kopieren
      this.chrom = (BitSet) chrom.clone(); 
      this.laenge = laenge;
   
   }

  
  /**
   ** Dieser Konstruktor erzeugt ein neues Chromosom.
   **
   */
  
   public Chromosom_bit(Chromosom_bit chrom)
   {
      // erzeugen eines neuen Chromosoms durch kopieren
      this.chrom = (BitSet) chrom.chrom().clone(); 
	  this.laenge = chrom.laenge();
   }


  /**
   ** Dieser Konstruktor eines Chromosoms erzeugt unter Verwendung
   ** von 2 anderen Chromosomen ein neues Chromosom.
   ** Das neue Chromosom (Kind) wird durch Crossover und Mutation
   ** der beiden Eltern erzeugt. 
   ** Die Reihenfolge, in der Vater und Mutter angegeben werden,
   ** entscheidet folglich wie das Kind aussieht.
   */

   public Chromosom_bit(Chromosom_bit parent1, Chromosom_bit parent2)
   {      
      // Ereugt unter Verwendung der Beiden Eltern ein neuens Chromosom
      chrom = new BitSet(parent1.laenge());
      laenge = parent1.laenge();
      crossover(parent1, parent2);
      //mutiere();
   }



   //_____________________________________________________________________
   // gibt die Laenge des Chromosoms zurck	
   public int laenge ()
   {      
      return laenge;
   }
 


   // Crossover;
   // Es wird einfach eine Crossoverstelle ermittelt und das entstehende
   // neue Chromosm besteht bis zur Crossoverstelle aus dem 1.Elternteil
   // und anschlieend aus dem 2.
   // Daraus geht hervor, dass die Reihenfolge von den beiden Elternteilen
   // wesentlich ist fuer das entstehende Chromosom.
   void crossover(Chromosom_bit parent1, Chromosom_bit parent2)
   {
      int i;
      int c_punkt;

      // Crossoverstelle
      c_punkt = GA.c_punkt(laenge);
      
      //System.out.println("Crossover bei C1 oder 3: Crossoverstelle: " + c_punkt);
      
      // Teil von parent1
      for (i=0; i<c_punkt; i++)
      {
         if (parent1.chrom.get(i))
            chrom.set(i);
         else
            chrom.clear(i);
      }

      // Teil von parent2
      for (i=c_punkt; i<laenge; i++)
      {
         if (parent2.chrom.get(i))
            chrom.set(i);
         else
            chrom.clear(i);
      }
   }


  // Mutation
  // dabei wird das ganze Chromosom durchgelaufen und 
  // bei jedem Bit wird abgefragt ob eine Mutation durchgefuehrt
  // werden soll oder nicht 
   void mutiere()
   {
      int i;

      for (i=0; i<laenge; i++)
      {
         if (GA.mutiere_C13(laenge) )
         {
         	//System.out.println("   Mutiere c1 oder c3");
            if (chrom.get(i))
               chrom.clear(i);
            else
               chrom.set(i);
         }
      }
   }


 
  // gibt das Chromsom zurueck (BitSet)
   public BitSet chrom()
   {	
      return chrom;
   }




  

}
