   package grunddaten;

   import java.util.*; //fuer StringTokenizer
   import java.lang.*;



/**
 * @stereotype type 
 */
   public class Point3d implements Cloneable {
   
    //koordinaten des point3d: (x vertikal, y horizontal, z tiefe)
      int x; //vorher: breite 
      int y; //vorher: laenge
      int z; //vorher: hoehe
   
    /* konstruktor: */
      public Point3d() {
         this(-1,-1,-1);
      }
   
    /* 2-dimensionaler konstruktor */
      public Point3d(int x, int y) {
         this(x, y, 0);
      }
   
    /* 3-dimensionaler konstruktor */
      public Point3d(int x, int y, int z) {
         super();
         this.x = x;
         this.y = y;
         this.z = z;
      }
   
    /* kopierkonstruktor: */
      public Point3d(Point3d punkt) {
         this(punkt.x, punkt.y, punkt.z);
      }
   
   
   
    //konstruktor mit konvertierung von string in point3d:
    //####################################################
    //////////////////////////////////////////////////////
    //textkonverter von string zu  point3d:             //
    //////////////////////////////////////////////////////
   
      public Point3d (String str) {
      
      //umwandeln des strings in einen StringTokenizer:
         StringTokenizer teilstrings = new StringTokenizer(str, ",./;"); //, . ; / werden als teilstrings ueberlesen
      
      //teilstrings in int umwandeln:
         String str_x = (String) teilstrings.nextElement();
         int x = Integer.parseInt(str_x);
         String str_y = (String) teilstrings.nextElement();
         int y = Integer.parseInt(str_y);	
         String str_z = (String) teilstrings.nextElement();
         int z = Integer.parseInt(str_z);
      
      //konstruieren des Point3d:
         this.x = x;
         this.y = y;
         this.z = z;
      
      }
   
     // ausgabe der y-Koordinate eines point3d:
      public int ausgabe_y() {
         return y;
      }
   
    //ausgabe der x-Koordinate eines point3d:
      public int ausgabe_x() {
         return x;
      }
   
    //ausgabe der z-koordinate eines point3d:
      public int ausgabe_z() {
         return z;
      }
   
     // aendern der x-Koordinate eines point3d:
      public void aendere_x(int x) {
         this.x = x;
      }
   
      public String ausgabe_string() {
			return (Integer.toString(x) + "," +
      			  Integer.toString(y) + "," +
      			  Integer.toString(z));
      }
   
    //aendern der y-Koordinate eines point3d:
      public void aendere_y(int y) {
         this.y = y;
      }
   
    //aendern der z-koordinate eines point3d:
      public void aendere_z(int z) {
         this.y = y;
      }
   
   
     //Clonen eines Point3d
      public Object clone() {
      
         Object o = null;
         try {
            o = super.clone();
         }
         
            catch(CloneNotSupportedException e) {
               System.out.println("Point3d kann nicht geklont werden");
            }
         return o;
      }
   
   
   
   }
